/*---------------------------------------------------------------------------
* 							Dr. Fritz Faulhaber GmbH & Co.KG
*----------------------------------------------------------------------------
*	Main module of the demo project
*	Provides functions for asynchronous data reception
*/
//---------------------------------------------------------------------------

#include "MainForm.h"

using namespace System;
using namespace System::Windows::Forms;

[STAThread]
int WINAPI WinMain(
	_In_ HINSTANCE hInstance,
	_In_opt_ HINSTANCE hPrevInstance,
	_In_ LPSTR lpCmdLine,
	_In_ int nShowCmd
	)
{
    Application::EnableVisualStyles();
    Application::SetCompatibleTextRenderingDefault(false);
    Application::Run(gcnew DemoVCPP::MainForm);
}
//---------------------------------------------------------------------------

namespace DemoVCPP {
	
	/**
	* Read and display asynchronous received data from the communication library
	*/
	void MainForm::AsyncDataReceived()
	{
		//Asynchronous data received
		std::string data, cmd;
		momanLibSample->ReadReceivedData(data, cmd);
		if (cmd != "") {
			String^ text = gcnew String(("Async Received: " + data + " (Cmd = " + cmd + ")").c_str());
			this->tb_Commlog->AppendText(text + L"\r\n");
		}
		else {
			String^ text = gcnew String(("Async Received: " + data).c_str());
			this->tb_Commlog->AppendText(text + L"\r\n");
		}

		if ((momanLibSample->GetStatusword() & 0x00FF) == 0x0027) {	//"Operation Enabled"
			btnRelPos->Enabled = true;
		}
		else {
			btnRelPos->Enabled = false;
		}
	}
	//---------------------------------------------------------------------------
	
	/**
	* Callback function, called from the communication library
	* when receiving asynchronous data
	*/
	void __stdcall CBAsyncDataReceived()
	{
		SetEvent(hReceiveEvent);
	}
	//---------------------------------------------------------------------------
	
	/**
	* Working thread
	*/
	void EventReceiver()
    {
        while (!threadTerminated)
        {
			if (WaitForSingleObject(hReceiveEvent, INFINITE) == WAIT_OBJECT_0) {
				if (!threadTerminated) {
					MainForm::_instance->Invoke(gcnew MethodInvoker(MainForm::_instance, &MainForm::AsyncDataReceived));
				}
			}
			Sleep(1);
        }
    }
	//---------------------------------------------------------------------------

}
//---------------------------------------------------------------------------
